diff -EbwBru 6.0.0.M1/org/jboss/mx/metadata/MethodMapper.java trunk/org/jboss/mx/metadata/MethodMapper.java
--- 6.0.0.M1/org/jboss/mx/metadata/MethodMapper.java	2009-11-30 14:39:18.000000000 -0600
+++ trunk/org/jboss/mx/metadata/MethodMapper.java	2009-12-10 12:42:23.000000000 -0600
@@ -39,13 +39,15 @@
  *
  * @author  <a href="mailto:trevor@protocool.com">Trevor Squires</a>.
  */
-
+@SuppressWarnings("unchecked")
 public class MethodMapper
 {
    private HashMap map = null;
 
    /**
     * Constructs a mapper by reflecting on the class.
+    * 
+    * @param resourceClass the resource class
     */
    public MethodMapper(Class resourceClass)
    {
@@ -59,6 +61,9 @@
 
    /**
     * Return a method matching the signature defined in the operation info
+    * 
+    * @param info the operation info
+    * @return the method
     */
    public Method lookupOperation(MBeanOperationInfo info)
    {
@@ -72,6 +77,9 @@
 
    /**
     * Return a method matching the getter signature expected for an attribute.
+    * 
+    * @param info the attribute info
+    * @return the method
     */
    public Method lookupGetter(MBeanAttributeInfo info)
    {
@@ -85,6 +93,9 @@
 
    /**
     * Return a method matching the getter signature expected for a ModelMBean attribute.
+    * 
+    * @param info the attribute info
+    * @return the method
     */
    public Method lookupGetter(ModelMBeanAttributeInfo info)
    {
@@ -98,6 +109,9 @@
 
    /**
     * Return a method matching the setter signature expected for an attribute
+    * 
+    * @param info the attribute info
+    * @return the method
     */
    public Method lookupSetter(MBeanAttributeInfo info)
    {
@@ -111,6 +125,9 @@
 
    /**
     * Return a method matching the setter signature expected for a ModelMBean attribute
+    * 
+    * @param info the attribute info
+    * @return the method
     */
    public Method lookupSetter(ModelMBeanAttributeInfo info)
    {
@@ -124,6 +141,11 @@
 
    /**
     * Return a method matching the specified signature
+    * 
+    * @param returnType the return type
+    * @param name the name
+    * @param signature the signature
+    * @return the method
     */
    public Method lookupMethod(String returnType, String name, String[] signature)
    {
@@ -142,6 +164,9 @@
 
    /**
     * Generates a signature string for an attribute getter method using standard rules
+    * 
+    * @param info the attribute info
+    * @return the signature
     */
    public static String getterSignature(MBeanAttributeInfo info)
    {
@@ -157,6 +182,9 @@
    /**
     * Generates a getter signature string for a ModelMBean attribute by checking the
     * descriptor for getMethod.
+    * 
+    * @param info the attribute info
+    * @return the signature
     */
    public static String getterSignature(ModelMBeanAttributeInfo info)
    {
@@ -177,6 +205,9 @@
 
    /**
     * Generates a signature string for an attribute setter method using standard rules
+    * 
+    * @param info the attribute info
+    * @return the signature
     */
    public static String setterSignature(MBeanAttributeInfo info)
    {
@@ -191,6 +222,9 @@
    /**
     * Generates a setter signature string for a ModelMBean attribute by checking the
     * descriptor for setMethod.
+    * 
+    * @param info the attribute info
+    * @return the signature
     */
    public static String setterSignature(ModelMBeanAttributeInfo info)
    {
@@ -211,6 +245,9 @@
 
    /**
     * Generates a signature string using the operation info.
+    * 
+    * @param info the operation info
+    * @return the signature
     */
    public static String operationSignature(MBeanOperationInfo info)
    {
@@ -230,6 +267,9 @@
 
    /**
     * Generates a signature string using a Method object.
+    * 
+    * @param method the method
+    * @return the signature
     */
    public static String methodSignature(Method method)
    {
@@ -249,6 +289,11 @@
 
    /**
     * Generates a signature string using the supplied signature arguments.
+    * 
+    * @param returnType the return type
+    * @param name the name
+    * @param signature the signature
+    * @return the signature
     */
    public static String methodSignature(String returnType, String name, String[] signature)
    {
@@ -277,7 +322,11 @@
 
    /**
     * creates the signature string to Method HashMap.
+    * 
+    * @param resourceClass the resource class
+    * @return the map
     */
+   @SuppressWarnings("unchecked")
    protected HashMap createMap(Class resourceClass)
    {
       HashMap cmap = new HashMap();
diff -EbwBru 6.0.0.M1/org/jboss/mx/metadata/StandardMetaData.java trunk/org/jboss/mx/metadata/StandardMetaData.java
--- 6.0.0.M1/org/jboss/mx/metadata/StandardMetaData.java	2009-11-30 14:39:18.000000000 -0600
+++ trunk/org/jboss/mx/metadata/StandardMetaData.java	2009-12-10 12:42:23.000000000 -0600
@@ -21,6 +21,7 @@
  */
 package org.jboss.mx.metadata;
 
+import java.lang.annotation.Annotation;
 import java.lang.reflect.Constructor;
 import java.lang.reflect.Method;
 import java.util.ArrayList;
@@ -28,14 +29,21 @@
 import java.util.Iterator;
 import java.util.List;
 
+import javax.management.Description;
 import javax.management.IntrospectionException;
+import javax.management.MBean;
 import javax.management.MBeanAttributeInfo;
 import javax.management.MBeanConstructorInfo;
 import javax.management.MBeanInfo;
 import javax.management.MBeanNotificationInfo;
 import javax.management.MBeanOperationInfo;
+import javax.management.MBeanParameterInfo;
+import javax.management.ManagedAttribute;
+import javax.management.ManagedOperation;
 import javax.management.NotCompliantMBeanException;
 import javax.management.NotificationBroadcaster;
+import javax.management.NotificationInfo;
+import javax.management.NotificationInfos;
 
 /**
  * This metadata builder implementation builds a MBean info based on the
@@ -43,7 +51,7 @@
  * to generate the metadata for Standard MBeans.  <p>
  *
  * In cooperation with the 
- * {@link MBeanInfoConversion#toModelMBeanInfo MBeanInfoConversion} class you
+ * {@link MBeanInfoConversion#toModelMBeanInfo(MBeanInfo) MBeanInfoConversion} class you
  * can use this builder as a migration tool from Standard to Model MBeans, or
  * for cases where you want the management interface be based on a compile-time
  * type safe interface. It is also possible to subclass this builder
@@ -69,12 +77,12 @@
    /**
     * The class of the MBean instance. 
     */
-   private Class mbeanClass    = null;
+   private Class<?> mbeanClass    = null;
    
    /**
     * The interface used as a basis for constructing the MBean metadata.
     */
-   private Class mbeanInterface    = null;
+   private Class<?> mbeanInterface    = null;
 
 
    // Static --------------------------------------------------------
@@ -87,10 +95,10 @@
     *
     * @return  the Standard MBean interface class or <tt>null</tt> if not found
     */
-   public static Class findStandardInterface(Class mbeanClass)
+   public static Class<?> findStandardInterface(Class<?> mbeanClass)
    {
-      Class concrete = mbeanClass;
-      Class stdInterface = null;
+      Class<?> concrete = mbeanClass;
+      Class<?> stdInterface = null;
       while (null != concrete)
       {
          stdInterface = findStandardInterface(concrete, concrete.getInterfaces());
@@ -103,10 +111,10 @@
       return null;
    }
 
-   private static Class findStandardInterface(Class concrete, Class[] interfaces)
+   private static Class<?> findStandardInterface(Class<?> concrete, Class<?>[] interfaces)
    {
       String stdName = concrete.getName() + "MBean";
-      Class retval = null;
+      Class<?> retval = null;
 
       // look to see if this class implements MBean std interface
       for (int i = 0; i < interfaces.length; ++i)
@@ -129,6 +137,7 @@
     * on the class of the given resource instance.
     * 
     * @param   mbeanInstance  MBean instance
+    * @throws NotCompliantMBeanException for any error
     */
    public StandardMetaData(Object mbeanInstance) throws NotCompliantMBeanException
    {
@@ -142,12 +151,13 @@
     *
     * @param   mbeanClass  resource class that implements an interface
     *                      adhering to the Standard MBean naming conventions
+    * @throws NotCompliantMBeanException for any error
     */
-   public StandardMetaData(Class mbeanClass)  throws NotCompliantMBeanException
+   public StandardMetaData(Class<?> mbeanClass)  throws NotCompliantMBeanException
    {
       this.mbeanClass     = mbeanClass;
       this.mbeanInterface = StandardMetaData.findStandardInterface(mbeanClass);
-      if (this.mbeanInterface == null)
+      if (this.mbeanInterface == null && mbeanClass.isAnnotationPresent(MBean.class) == false)
          throw new NotCompliantMBeanException("Cannot obtain management interface for: " + mbeanClass);
    }
 
@@ -157,8 +167,9 @@
     * 
     * @param   mbInstance  MBean instance
     * @param   mbInterface the management interface
+    * @throws NotCompliantMBeanException for any error
     */
-   public StandardMetaData(Object mbInstance, Class mbInterface) throws NotCompliantMBeanException
+   public StandardMetaData(Object mbInstance, Class<?> mbInterface) throws NotCompliantMBeanException
    {
       this.mbeanInstance = mbInstance;
       this.mbeanClass = mbInstance.getClass();
@@ -176,16 +187,23 @@
 
    /**
     * Retrieve the management interface
+    * 
+    * @return the interface
     */
-   public Class getMBeanInterface()
+   public Class<?> getMBeanInterface()
    {
       return mbeanInterface;
    }
    
    // MetaDataBuilder implementation --------------------------------
 
+   @SuppressWarnings("unchecked")
    public MBeanInfo build() throws NotCompliantMBeanException
    {
+      // We have an annotated class
+      if (mbeanClass.isAnnotationPresent(MBean.class))
+         return buildFromAnnotations();
+
       try
       {
          // First check the mbean instance implements the interface
@@ -196,12 +214,10 @@
                                                  mbeanInterface.getName());
 
          // First build the constructors
-         Constructor[] constructors = mbeanClass.getConstructors();
+         Constructor<?>[] constructors = mbeanClass.getConstructors();
          MBeanConstructorInfo[] constructorInfo = new MBeanConstructorInfo[constructors.length];
          for (int i = 0; i < constructors.length; ++i)
-         {
             constructorInfo[i] = new MBeanConstructorInfo("MBean Constructor.", constructors[i]);
-         }
 
          // Next we have to figure out how the methods in the mbean class map
          // to attributes and operations
@@ -304,19 +320,206 @@
       }
    }
 
+   public MBeanInfo buildFromAnnotations() throws NotCompliantMBeanException
+   {
+      try
+      {
+         // First build the constructors
+         Constructor<?>[] constructors = mbeanClass.getConstructors();
+         MBeanConstructorInfo[] constructorInfo = new MBeanConstructorInfo[constructors.length];
+         for (int i = 0; i < constructors.length; ++i)
+         {
+            String desc = "MBean Constructor.";
+            Description description = constructors[i].getAnnotation(Description.class);
+            if (description != null)
+               desc = description.value();
+            MBeanParameterInfo[] signature = getSignature(constructors[i]);
+            constructorInfo[i] = new MBeanConstructorInfo(desc, desc, signature);
+         }
+
+         // Next we have to figure out how the methods in the mbean class map
+         // to attributes and operations
+         Method[] methods = mbeanClass.getMethods();
+         HashMap<String, Method> getters = new HashMap<String, Method>();
+         HashMap<String, Method> setters = new HashMap<String, Method>();
+
+         HashMap<String, MBeanOperationInfo> operInfo = new HashMap<String, MBeanOperationInfo>();
+         List<MBeanAttributeInfo> attrInfo = new ArrayList<MBeanAttributeInfo>();
+
+         for (int i = 0; i < methods.length; ++i)
+         {
+            if (methods[i].isAnnotationPresent(ManagedAttribute.class))
+            {
+               String methodName = methods[i].getName();
+               Class<?>[] signature = methods[i].getParameterTypes();
+               Class<?> returnType  = methods[i].getReturnType();
+
+               if (methodName.startsWith("set") && methodName.length() > 3 
+                       && signature.length == 1 && returnType == Void.TYPE)
+               {
+                  String key = methodName.substring(3, methodName.length());
+                  Method setter = setters.get(key);
+                  if (setter != null && setter.getParameterTypes()[0].equals(signature[0]) == false)
+                     throw new IntrospectionException("overloaded type for attribute set: " + key);
+                  setters.put(key, methods[i]);
+               }
+               else if (methodName.startsWith("get") && methodName.length() > 3 
+                            && signature.length == 0 && returnType != Void.TYPE)
+               {
+                  String key = methodName.substring(3, methodName.length());
+                  Method getter = getters.get(key);
+                  if (getter != null && getter.getName().startsWith("is"))
+                     throw new IntrospectionException("mixed use of get/is for attribute " + key);
+                  getters.put(key, methods[i]);
+               }
+               else if (methodName.startsWith("is") && methodName.length() > 2 
+                           && signature.length == 0 && isBooleanReturn(returnType))
+               {
+                  String key = methodName.substring(2, methodName.length());
+                  Method getter = getters.get(key);
+                  if (getter != null && getter.getName().startsWith("get"))
+                  {
+                     throw new IntrospectionException("mixed use of get/is for attribute " + key);
+                  }
+                  getters.put(key, methods[i]);
+               }
+            }
+            ManagedOperation operation = methods[i].getAnnotation(ManagedOperation.class);
+            if (operation != null)
+            {
+               String desc = "MBean Operation.";
+               Description description = methods[i].getAnnotation(Description.class);
+               if (description != null)
+                  desc = description.value();
+               int impact = operation.impact().getCode();
+               MBeanParameterInfo[] sign = getSignature(methods[i]);
+               MBeanOperationInfo info = new MBeanOperationInfo(methods[i].getName(), desc, sign, methods[i].getReturnType().getName(), impact);
+               operInfo.put(getSignatureString(methods[i]), info);
+            }
+         }
+
+         String[] keys = getters.keySet().toArray(new String[0]);
+         for (int i = 0; i < keys.length; ++i)
+         {
+            String attrName = keys[i];
+            Method getter = getters.remove(attrName);
+            Method setter = setters.remove(attrName);
+            
+            String desc = "MBean Attribute.";
+            Description description = getter.getAnnotation(Description.class);
+            if (description != null)
+               desc = description.value();
+            else if (setter != null)
+            {
+               description = setter.getAnnotation(Description.class);
+               if (description != null)
+                  desc = description.value();
+            }
+            MBeanAttributeInfo info = new MBeanAttributeInfo(attrName, desc, getter, setter);
+            attrInfo.add(info);
+         }
+
+         for (String attrName : setters.keySet())
+         {
+            Method setter = setters.get(attrName);
+            String desc = "MBean Attribute.";
+            Description description = setter.getAnnotation(Description.class);
+            if (description != null)
+               desc = description.value();
+            MBeanAttributeInfo info = new MBeanAttributeInfo(attrName, desc, null, setter);
+            attrInfo.add(info);
+         }
+
+         // save away the attribute and operation info objects
+         MBeanAttributeInfo[] attributeInfo = attrInfo.toArray(new MBeanAttributeInfo[0]);
+         MBeanOperationInfo[] operationInfo = operInfo.values().toArray(new MBeanOperationInfo[0]);
+
+         // TODO
+         NotificationInfo[] notifs = null;
+         NotificationInfos notifInfos = mbeanClass.getAnnotation(NotificationInfos.class);
+         if (notifInfos != null)
+            notifs = notifInfos.value();
+         else
+         {
+            NotificationInfo notifInfo = mbeanClass.getAnnotation(NotificationInfo.class);
+            if (notifInfo != null)
+               notifs = new NotificationInfo[] { notifInfo };
+         }
+
+         MBeanNotificationInfo[] notifications = null;
+         if (notifs == null)
+         {
+            notifications = new MBeanNotificationInfo[0];
+         }
+         else
+         {
+            notifications = new MBeanNotificationInfo[notifs.length];
+            for (int i = 0; i < notifs.length; ++i)
+            {
+               String desc = "MBean Notification.";
+               String description = notifs[i].description().value();
+               if (description.length() > 0)
+                  desc = description;
+               notifications[i] = new MBeanNotificationInfo(notifs[i].types(), notifs[i].notificationClass().getName(), desc);
+            }
+         }
+         
+         String desc = "Management Bean.";
+         Description description = mbeanClass.getAnnotation(Description.class);
+         if (description != null)
+            desc = description.value();
+         return new MBeanInfo(mbeanClass.getName(), desc,
+               attributeInfo, constructorInfo, operationInfo, notifications);
+      }
+      catch (IntrospectionException e)
+      {
+         throw new NotCompliantMBeanException(e.getMessage());
+      }
+   }
+
    /**
     * JMX standard specifies that only "boolean isX()" style methods
     * represent attributes. "Boolean isX()" methods map to operations.
     */
-   private boolean isBooleanReturn(Class returnType)
+   private boolean isBooleanReturn(Class<?> returnType)
    {
       return returnType == Boolean.TYPE;
    }
 
+   protected MBeanParameterInfo[] getSignature(Constructor<?> constructor)
+   {
+      return getSignature(constructor.getParameterTypes(), constructor.getParameterAnnotations());
+   }
+
+   protected MBeanParameterInfo[] getSignature(Method method)
+   {
+      return getSignature(method.getParameterTypes(), method.getParameterAnnotations());
+   }
+
+   protected MBeanParameterInfo[] getSignature(Class<?>[] parameterTypes, Annotation[][] annotations)
+   {
+      MBeanParameterInfo[] result = new MBeanParameterInfo[parameterTypes.length];
+      for (int i = 0; i < result.length; ++i)
+      {
+         String name = "p" + i;
+         String desc = name;
+         for (Annotation annotation : annotations[i])
+         {
+            if (annotation.annotationType() == Description.class)
+            {
+               Description description = (Description) annotation;
+               desc = description.value();
+            }
+         }
+         result[i] = new MBeanParameterInfo(name, parameterTypes[i].getName(), desc);
+      }
+      return result;
+   }
+   
    protected String getSignatureString(Method method)
    {
       String name = method.getName();
-      Class[] signature = method.getParameterTypes();
+      Class<?>[] signature = method.getParameterTypes();
       StringBuffer buffer = new StringBuffer(512);
       buffer.append(name);
       buffer.append("(");
diff -EbwBru 6.0.0.M1/org/jboss/mx/metadata/xb/DescriptorSupportContainer.java trunk/org/jboss/mx/metadata/xb/DescriptorSupportContainer.java
--- 6.0.0.M1/org/jboss/mx/metadata/xb/DescriptorSupportContainer.java	2009-11-30 14:39:18.000000000 -0600
+++ trunk/org/jboss/mx/metadata/xb/DescriptorSupportContainer.java	2009-12-10 12:42:23.000000000 -0600
@@ -31,7 +31,7 @@
 
 /**
  @author Scott.Stark@jboss.org
- @version $Revision: 81026 $
+ @version $Revision: 85671 $
  */
 public class DescriptorSupportContainer
    implements GenericValueContainer
@@ -119,7 +119,7 @@
       }
    }
 
-   public Class getTargetClass()
+   public Class<?> getTargetClass()
    {
       return DescriptorSupport.class;
    }
diff -EbwBru 6.0.0.M1/org/jboss/mx/metadata/xb/InterceptorHolder.java trunk/org/jboss/mx/metadata/xb/InterceptorHolder.java
--- 6.0.0.M1/org/jboss/mx/metadata/xb/InterceptorHolder.java	2009-11-30 14:39:18.000000000 -0600
+++ trunk/org/jboss/mx/metadata/xb/InterceptorHolder.java	2009-12-10 12:42:23.000000000 -0600
@@ -31,12 +31,12 @@
  A container for the interceptor elements.
  
  @author Scott.Stark@jboss.org
- @version $Revision: 81026 $
+ @version $Revision: 85671 $
  */
 public class InterceptorHolder
    implements GenericValueContainer
 {
-   private Class clazz;
+   private Class<?> clazz;
 
    public void addChild(QName name, Object value)
    {
@@ -71,7 +71,7 @@
       return i;
    }
 
-   public Class getTargetClass()
+   public Class<?> getTargetClass()
    {
       return Interceptor.class;
    }
diff -EbwBru 6.0.0.M1/org/jboss/mx/metadata/xb/InterceptorsHolder.java trunk/org/jboss/mx/metadata/xb/InterceptorsHolder.java
--- 6.0.0.M1/org/jboss/mx/metadata/xb/InterceptorsHolder.java	2009-11-30 14:39:18.000000000 -0600
+++ trunk/org/jboss/mx/metadata/xb/InterceptorsHolder.java	2009-12-10 12:42:23.000000000 -0600
@@ -22,16 +22,15 @@
 package org.jboss.mx.metadata.xb;
 
 import java.util.ArrayList;
-import java.util.List;
 
 import org.jboss.mx.interceptor.Interceptor;
 
 /**
  @author Scott.Stark@jboss.org
- @version $Revision: 81026 $ */
+ @version $Revision: 85671 $ */
 public class InterceptorsHolder
 {
-   private ArrayList interceptors = new ArrayList();
+   private ArrayList<Interceptor> interceptors = new ArrayList<Interceptor>();
 
    public void addInterceptor(Interceptor i)
    {
diff -EbwBru 6.0.0.M1/org/jboss/mx/metadata/xb/ModelMBeanAttributeInfoContainer.java trunk/org/jboss/mx/metadata/xb/ModelMBeanAttributeInfoContainer.java
--- 6.0.0.M1/org/jboss/mx/metadata/xb/ModelMBeanAttributeInfoContainer.java	2009-11-30 14:39:18.000000000 -0600
+++ trunk/org/jboss/mx/metadata/xb/ModelMBeanAttributeInfoContainer.java	2009-12-10 12:42:23.000000000 -0600
@@ -35,7 +35,7 @@
 /**
  * The ModelMBeanAttributeInfo JBossXB container 
  * @author Scott.Stark@jboss.org
- * @version $Revision: 81026 $
+ * @version $Revision: 85671 $
  */
 public class ModelMBeanAttributeInfoContainer
    implements GenericValueContainer
@@ -170,7 +170,7 @@
          this.description = (String) value;
       }
    }
-   public Class getTargetClass()
+   public Class<?> getTargetClass()
    {
       return ModelMBeanAttributeInfo.class;
    }
diff -EbwBru 6.0.0.M1/org/jboss/mx/metadata/xb/ModelMBeanConstructorInfoContainer.java trunk/org/jboss/mx/metadata/xb/ModelMBeanConstructorInfoContainer.java
--- 6.0.0.M1/org/jboss/mx/metadata/xb/ModelMBeanConstructorInfoContainer.java	2009-11-30 14:39:18.000000000 -0600
+++ trunk/org/jboss/mx/metadata/xb/ModelMBeanConstructorInfoContainer.java	2009-12-10 12:42:23.000000000 -0600
@@ -34,7 +34,7 @@
 /**
  * The ModelMBeanConstructorInfo JBossXB container 
  * @author Scott.Stark@jboss.org
- * @version $Revision: 81026 $
+ * @version $Revision: 85671 $
  */
 public class ModelMBeanConstructorInfoContainer
    implements GenericValueContainer
@@ -42,7 +42,7 @@
    private static final Logger log = Logger.getLogger(ModelMBeanConstructorInfoContainer.class);
    private String name;
    private String description;
-   private ArrayList params = new ArrayList();
+   private ArrayList<MBeanParameterInfo> params = new ArrayList<MBeanParameterInfo>();
    private Descriptor descriptor;
 
    public Descriptor getDescriptors()
@@ -86,7 +86,7 @@
          this.description = (String) value;
       }
    }
-   public Class getTargetClass()
+   public Class<?> getTargetClass()
    {
       return ModelMBeanConstructorInfo.class;
    }
diff -EbwBru 6.0.0.M1/org/jboss/mx/metadata/xb/ModelMBeanInfoSupportWrapper.java trunk/org/jboss/mx/metadata/xb/ModelMBeanInfoSupportWrapper.java
--- 6.0.0.M1/org/jboss/mx/metadata/xb/ModelMBeanInfoSupportWrapper.java	2009-11-30 14:39:18.000000000 -0600
+++ trunk/org/jboss/mx/metadata/xb/ModelMBeanInfoSupportWrapper.java	2009-12-10 12:42:23.000000000 -0600
@@ -22,25 +22,25 @@
 package org.jboss.mx.metadata.xb;
 
 import java.util.ArrayList;
-import javax.management.modelmbean.ModelMBeanOperationInfo;
+
+import javax.management.Descriptor;
 import javax.management.modelmbean.ModelMBeanAttributeInfo;
 import javax.management.modelmbean.ModelMBeanConstructorInfo;
-import javax.management.modelmbean.ModelMBeanNotificationInfo;
 import javax.management.modelmbean.ModelMBeanInfo;
 import javax.management.modelmbean.ModelMBeanInfoSupport;
-import javax.management.Descriptor;
+import javax.management.modelmbean.ModelMBeanNotificationInfo;
+import javax.management.modelmbean.ModelMBeanOperationInfo;
 
-import org.jboss.logging.Logger;
 import org.jboss.mx.modelmbean.ModelMBeanConstants;
 
 /**
  * A javabean wrapper used to construct a ModelMBeanInfoSupport
  * @author Scott.Stark@jboss.org
- * @version $Revision: 81026 $
+ * @version $Revision: 85671 $
  */
+@SuppressWarnings("unchecked")
 public class ModelMBeanInfoSupportWrapper
 {
-   private static final Logger log = Logger.getLogger(ModelMBeanInfoSupportWrapper.class);
    private String mmbClassName = "org.jboss.mx.modelmbean.XMBean";
 
    private String description;
diff -EbwBru 6.0.0.M1/org/jboss/mx/metadata/xb/ModelMBeanNotificationInfoContainer.java trunk/org/jboss/mx/metadata/xb/ModelMBeanNotificationInfoContainer.java
--- 6.0.0.M1/org/jboss/mx/metadata/xb/ModelMBeanNotificationInfoContainer.java	2009-11-30 14:39:18.000000000 -0600
+++ trunk/org/jboss/mx/metadata/xb/ModelMBeanNotificationInfoContainer.java	2009-12-10 12:42:23.000000000 -0600
@@ -22,26 +22,26 @@
 package org.jboss.mx.metadata.xb;
 
 import java.util.ArrayList;
+
 import javax.management.Descriptor;
-import javax.management.modelmbean.DescriptorSupport;
 import javax.management.modelmbean.ModelMBeanNotificationInfo;
 import javax.xml.namespace.QName;
 
-import org.jboss.xb.binding.GenericValueContainer;
 import org.jboss.logging.Logger;
 import org.jboss.mx.modelmbean.ModelMBeanConstants;
+import org.jboss.xb.binding.GenericValueContainer;
 
 /**
  * The JBossXB ModelMBeanNotificationInfo container
  * @author Scott.Stark@jboss.org
- * @version $Revision: 81026 $
+ * @version $Revision: 85671 $
  */
 public class ModelMBeanNotificationInfoContainer
    implements GenericValueContainer
 {
    private static final Logger log = Logger.getLogger(ModelMBeanNotificationInfoContainer.class);
    private String name;
-   private ArrayList types = new ArrayList();
+   private ArrayList<String> types = new ArrayList<String>();
    private String description;
    private Descriptor descriptor;
 
@@ -91,7 +91,7 @@
          this.description = (String) value;
       }
    }
-   public Class getTargetClass()
+   public Class<?> getTargetClass()
    {
       return ModelMBeanNotificationInfo.class;
    }
diff -EbwBru 6.0.0.M1/org/jboss/mx/metadata/xb/ModelMBeanOperationInfoContainer.java trunk/org/jboss/mx/metadata/xb/ModelMBeanOperationInfoContainer.java
--- 6.0.0.M1/org/jboss/mx/metadata/xb/ModelMBeanOperationInfoContainer.java	2009-11-30 14:39:18.000000000 -0600
+++ trunk/org/jboss/mx/metadata/xb/ModelMBeanOperationInfoContainer.java	2009-12-10 12:42:23.000000000 -0600
@@ -36,7 +36,7 @@
 /**
  * The ModelMBeanOperationInfo JBossXB container 
  * @author Scott.Stark@jboss.org
- * @version $Revision: 81026 $
+ * @version $Revision: 85671 $
  */
 public class ModelMBeanOperationInfoContainer
    implements GenericValueContainer
@@ -46,7 +46,7 @@
    private String returnType = "void";
    private String impact;
    private String description;
-   private ArrayList params = new ArrayList();
+   private ArrayList<MBeanParameterInfo> params = new ArrayList<MBeanParameterInfo>();
    private Descriptor descriptor;
 
    public String getName()
@@ -144,7 +144,7 @@
          this.description = (String) value;
       }
    }
-   public Class getTargetClass()
+   public Class<?> getTargetClass()
    {
       return ModelMBeanOperationInfo.class;
    }
diff -EbwBru 6.0.0.M1/org/jboss/mx/metadata/XMLMetaData.java trunk/org/jboss/mx/metadata/XMLMetaData.java
--- 6.0.0.M1/org/jboss/mx/metadata/XMLMetaData.java	2009-11-30 14:39:18.000000000 -0600
+++ trunk/org/jboss/mx/metadata/XMLMetaData.java	2009-12-10 12:42:23.000000000 -0600
@@ -21,7 +21,7 @@
  */
 package org.jboss.mx.metadata;
 
-// $Id: XMLMetaData.java 81026 2008-11-14 12:51:05Z dimitris@jboss.org $
+// $Id: XMLMetaData.java 85671 2009-03-10 11:05:10Z adrian@jboss.org $
 
 import java.net.MalformedURLException;
 import java.net.URL;
@@ -134,7 +134,7 @@
     *                               to the appropriate XML schema specific builder
     *                               when it is created.
     */
-   public XMLMetaData(String mmbClassName, String resourceClassName, URL url, Map properties)
+   public XMLMetaData(String mmbClassName, String resourceClassName, URL url, Map<String, Object> properties)
    {
       this(mmbClassName, resourceClassName, url);
       setProperties(properties);
@@ -157,7 +157,7 @@
     * @throws  MalformedURLException if the URL string could not be resolved
     */
    public XMLMetaData(String mmbClassName, String resourceClassName,
-                      String url, Map properties) throws MalformedURLException
+                      String url, Map<String, Object> properties) throws MalformedURLException
    {
       this(mmbClassName, resourceClassName, new URL(url), properties);
    }
diff -EbwBru 6.0.0.M1/org/jboss/mx/modelmbean/ModelMBeanConstants.java trunk/org/jboss/mx/modelmbean/ModelMBeanConstants.java
--- 6.0.0.M1/org/jboss/mx/modelmbean/ModelMBeanConstants.java	2009-11-30 14:31:23.000000000 -0600
+++ trunk/org/jboss/mx/modelmbean/ModelMBeanConstants.java	2009-12-10 12:42:24.000000000 -0600
@@ -28,7 +28,7 @@
  * @author  <a href="mailto:thomas.diesler@jboss.com">Thomas Diesler</a>.
  * @author  <a href="mailto:dimitris@jboss.org">Dimitris Andreadis</a>.
  * @author Matt Munz
- * @version $Revision: 81019 $
+ * @version $Revision: 86129 $
  */
 public interface ModelMBeanConstants
 {
